﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        ToolTips_Init()
        '
        Load_INI()
        InitParams()
        '
        mtimer = New MilliTimer()
        mtimer.Interval = 5
        mtimer.Start()
        '
        Text = AppTitleAndVersion("")
        EventsAreEnabled = True
        Refresh()
        Opacity = 100
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        If mtimer IsNot Nothing Then mtimer.Stop()
        Save_INI()
        'End
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub


    ' ====================================================================================================
    '  Params
    ' ====================================================================================================
    Private FirstKeySlot As Int32
    Private ArrowUpSlot As Int32
    Private ArrowDownSlot As Int32
    Private ArrowLeftSlot As Int32
    Private ArrowRightSlot As Int32
    Private Velocity As Int32
    Private Octave As Int32

    Private Sub Params_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_FirstKeySlot.LostFocus, _
                                                                                              txt_ArrowUpSlot.LostFocus, _
                                                                                              txt_ArrowDownSlot.LostFocus, _
                                                                                              txt_ArrowLeftSlot.LostFocus, _
                                                                                              txt_ArrowRightSlot.LostFocus, _
                                                                                              txt_Velocity.LostFocus, _
                                                                                              txt_Octave.LostFocus
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub
    Private Sub Params_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_FirstKeySlot.MouseLeave, _
                                                                                          txt_ArrowUpSlot.MouseLeave, _
                                                                                          txt_ArrowDownSlot.MouseLeave, _
                                                                                          txt_ArrowLeftSlot.MouseLeave, _
                                                                                          txt_ArrowRightSlot.MouseLeave, _
                                                                                          txt_Velocity.MouseLeave, _
                                                                                          txt_Octave.MouseLeave
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
        Label_ArrowDownSlot.Focus()
        GroupBox_Controls.Focus()
    End Sub


    Private Sub txt_FirstKeySlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_FirstKeySlot.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        InitParams()
    End Sub
    Private Sub txt_ArrowUpSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrowUpSlot.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        InitParams()
    End Sub
    Private Sub txt_ArrowDownSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrowDownSlot.TextChanged
        InitParams()
    End Sub
    Private Sub txt_ArrowLeftSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrowLeftSlot.TextChanged
        InitParams()
    End Sub
    Private Sub txt_ArrowRightSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrowRightSlot.TextChanged
        InitParams()
    End Sub
    Private Sub txt_Velocity_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Velocity.TextChanged
        InitParams()
    End Sub
    Private Sub txt_Octave_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Octave.TextChanged
        InitParams()
    End Sub

    Private Sub InitParams()
        FirstKeySlot = txt_FirstKeySlot.NumericValueInteger
        ArrowUpSlot = txt_ArrowUpSlot.NumericValueInteger
        ArrowDownSlot = txt_ArrowDownSlot.NumericValueInteger
        ArrowLeftSlot = txt_ArrowLeftSlot.NumericValueInteger
        ArrowRightSlot = txt_ArrowRightSlot.NumericValueInteger
        Velocity = txt_Velocity.NumericValueInteger
        Octave = txt_Octave.NumericValueInteger
    End Sub


    ' ====================================================================================================
    '  MilliTimer
    ' ====================================================================================================
    Private WithEvents mtimer As MilliTimer
    Private Sub MilliTimerElapsed_ThreadSafe() Handles mtimer.MilliTimerElapsed
        Me.Invoke(New Action(Of Int32)(AddressOf MilliTimerElapsed), 0)
    End Sub
    Private Sub MilliTimerElapsed(ByVal n As Int32)
        PollSlots()
        'TestTime()
    End Sub
    'Private Sub TestTime()
    '    Static t As Double = 0
    '    t = t + mtimer.Interval
    '    If t >= 1000 Then
    '        t = 0
    '        'Beep()
    '        Me.Text = DateTime.Now.Millisecond.ToString
    '    End If
    'End Sub
    Friend Sub PollSlots()
        Dim n As Int32 = FirstKeySlot + 60 + txt_Octave.NumericValueInteger * 12
        Dim v As Single = Velocity * 1000.0F / 127.0F
        If Key(Keys.A) Then Slots.WriteSlot(n + 0, v) Else Slots.WriteSlot(n + 0, 0)
        If Key(Keys.W) Then Slots.WriteSlot(n + 1, v) Else Slots.WriteSlot(n + 1, 0)
        If Key(Keys.S) Then Slots.WriteSlot(n + 2, v) Else Slots.WriteSlot(n + 2, 0)
        If Key(Keys.E) Then Slots.WriteSlot(n + 3, v) Else Slots.WriteSlot(n + 3, 0)
        If Key(Keys.D) Then Slots.WriteSlot(n + 4, v) Else Slots.WriteSlot(n + 4, 0)
        If Key(Keys.F) Then Slots.WriteSlot(n + 5, v) Else Slots.WriteSlot(n + 5, 0)
        If Key(Keys.T) Then Slots.WriteSlot(n + 6, v) Else Slots.WriteSlot(n + 6, 0)
        If Key(Keys.G) Then Slots.WriteSlot(n + 7, v) Else Slots.WriteSlot(n + 7, 0)
        If Key(Keys.Y) Then Slots.WriteSlot(n + 8, v) Else Slots.WriteSlot(n + 8, 0)
        If Key(Keys.H) Then Slots.WriteSlot(n + 9, v) Else Slots.WriteSlot(n + 9, 0)
        If Key(Keys.U) Then Slots.WriteSlot(n + 10, v) Else Slots.WriteSlot(n + 10, 0)
        If Key(Keys.J) Then Slots.WriteSlot(n + 11, v) Else Slots.WriteSlot(n + 11, 0)
        If Key(Keys.K) Then Slots.WriteSlot(n + 12, v) Else Slots.WriteSlot(n + 12, 0)
        If Key(Keys.O) Then Slots.WriteSlot(n + 13, v) Else Slots.WriteSlot(n + 13, 0)
        If Key(Keys.L) Then Slots.WriteSlot(n + 14, v) Else Slots.WriteSlot(n + 14, 0)
        If Key(Keys.P) Then Slots.WriteSlot(n + 15, v) Else Slots.WriteSlot(n + 15, 0)
        If Key(Keys.Oemtilde) Then Slots.WriteSlot(n + 16, v) Else Slots.WriteSlot(n + 16, 0)
        If Key(Keys.Oem7) Then Slots.WriteSlot(n + 17, v) Else Slots.WriteSlot(n + 17, 0)
        If Key(Keys.Oemplus) Then Slots.WriteSlot(n + 18, v) Else Slots.WriteSlot(n + 18, 0)
        If Key(Keys.OemQuestion) Then Slots.WriteSlot(n + 19, v) Else Slots.WriteSlot(n + 19, 0)

        If Key(Keys.Up) Then Slots.WriteSlot(ArrowUpSlot, v) Else Slots.WriteSlot(ArrowUpSlot, 0)
        If Key(Keys.Down) Then Slots.WriteSlot(ArrowDownSlot, v) Else Slots.WriteSlot(ArrowDownSlot, 0)
        If Key(Keys.Left) Then Slots.WriteSlot(ArrowLeftSlot, v) Else Slots.WriteSlot(ArrowLeftSlot, 0)
        If Key(Keys.Right) Then Slots.WriteSlot(ArrowRightSlot, v) Else Slots.WriteSlot(ArrowRightSlot, 0)
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        'Text = e.KeyCode.ToString
    End Sub


    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 700
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_FirstKeySlot, _
                        " First key slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The number of the first slot starting from the key ""A""." & vbCrLf & _
                        " 20 consecutive slots.")

        ttp1.SetToolTip(txt_ArrowUpSlot, _
                        " Arrow up slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " .")

        ttp1.SetToolTip(txt_ArrowDownSlot, _
                        " Arrow down slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " .")

        ttp1.SetToolTip(txt_ArrowLeftSlot, _
                        " Arrow left slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " .")

        ttp1.SetToolTip(txt_ArrowRightSlot, _
                        " Arrow right slot" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " .")

        ttp1.SetToolTip(txt_Velocity, _
                        " Velocity" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The velocity (0 to 127 musical translated to 0 to 1000 in the slots)")

        ttp1.SetToolTip(txt_Octave, _
                        " Octave" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " Octave zero translates slots UP by 60 places." & vbCrLf & _
                        " Use a value of -5 to associate the key ""A"" to the first slot.")

    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub controls_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles txt_FirstKeySlot.MouseEnter, _
                                                                        txt_ArrowUpSlot.MouseEnter, _
                                                                        txt_ArrowDownSlot.MouseEnter, _
                                                                        txt_ArrowLeftSlot.MouseEnter, _
                                                                        txt_ArrowRightSlot.MouseEnter, _
                                                                        txt_Velocity.MouseEnter, _
                                                                        txt_Octave.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub

End Class